@echo off
REM for a psycho test, use 6 disconnected computers , 
REM   one for qgenHid
REM   for each arm, one for qRotat
REM   for each arm, one for qPolarize
REM   one for qStat

rem ***** i'm not so familiar with bat files and their weird usage *****
rem ***** be aware when extending the code ******

REM ##### default values for all the used parameters #########

REM float version is the default
SET V=

REM use V i for the integer version or only i
REM V=i


REM number of initial pairs
SET num_pat=10000000

REM index of the test if you need to keep history
SET num_test=1

REM nick names of the arms
SET arm1=alice
SET arm2=bob

REM depth parameters

REM ring size in degrees around the angle
SET largarc=25.75

REM number of sections in this ring
SET section=7

REM number of doors of the potential
SET doors=20

REM base of the restriction to 4 angles
SET R=

SET tab=	

if "%1" == "h" ( 
	echo %tab%batdos.bat argument value ...
	echo %tab%%tab%if an argument is not specified, the default value is used
	echo %tab%ex : batdos.bat largarc 20 section 5 doors 12
	echo %tab% _
	echo %tab%All the default values may be overridden:
	echo %tab%%tab%V %V% :: float version ; use V i for the integer version or only i
	echo %tab%%tab%num_pat %num_pat%	 :: number of initial pairs
	echo %tab%%tab%num_test %num_test% :: index of the test if you need to keep history
	echo %tab%%tab%arm1 %arm1% :: nick names of the arms
	echo %tab%%tab%arm2 %arm2%
	echo %tab%%tab%largarc %largarc%  :: ring size in degrees around the angle
	echo %tab%%tab%section %section%  :: number of sections in this ring
	echo %tab%%tab%doors %doors% :: number of doors of the potential
	echo %tab%%tab%R %R%  :: base of the restriction to 4 angles , ignore for all
	echo %tab% _
	echo %tab%%tab%for a copy/paste/edit :
	echo batdos.bat V i num_pat %num_pat% num_test %num_test% arm1 %arm1% arm2 %arm2% largarc %largarc% section %section% doors %doors%
	echo %tab% _
EXIT /B
)

rem ugly code because bat doesn't treat shift in regular structure ( if ()() etc )

:loop01
if "%1"=="" goto endloop1
	if not "%1" == "i" goto tag3
		SET V=i
		shift
	goto loop01
:tag3
		set %1=%2
		shift
		shift
	goto loop01
:endloop1

if "%R" == "4" ( 
	SET restr1=0
	SET restr2=2
) else (
	SET restr1=
	SET restr2=
)

REM generate the common variables files ( also called hidden variables file )
.\bin\%V%qgenHid %num_pat% data\hid.%num_test%.%num_pat%

REM compute the rotations of the arm 1
.\bin\%V%qRotat %num_pat% data\%arm1%.rot.%num_test%.%num_pat% %restr1%


REM compute the polarisations of the arm 1 with the common hidden variables and the arm1 rotations files 
.\bin\%V%qPolarize %largarc% %section% %doors% data\hid.%num_test%.%num_pat% data\%arm1%.rot.%num_test%.%num_pat% data\%arm1%.polarized.%num_test%.%num_pat%

REM compute the rotations of the arm 2
REM because the randomizer is seeded on the time, you must include between the 2 rotations computations a long command or a sleep
.\bin\%V%qRotat %num_pat% data\%arm2%.rot.%num_test%.%num_pat% %restr2%

REM compute the polarisations of the arm 2 with the common hidden variables and the arm2 rotations files 
.\bin\%V%qPolarize %largarc% %section% %doors% data\hid.%num_test%.%num_pat% data\%arm2%.rot.%num_test%.%num_pat% data\%arm2%.polarized.%num_test%.%num_pat%

REM do the stats with the output of the polarizer
.\bin\%V%qStat data\%arm1%.polarized.%num_test%.%num_pat% data\%arm2%.polarized.%num_test%.%num_pat% data\%arm1%.%arm2%.%num_test%.%num_pat%

REM you can either analyze the tabbed document with you software, with an excel-like software or rewrite qStat to fit your needs

REM optionnal - to ignore in most cases
copy data\%arm1%.%arm2%.%num_test%.%num_pat% txt\%arm1%.%arm2%.%num_test%.%num_pat%.csv
dir data\
dir txt\

